! ===========================================================================================================
! integer function qc13_stuck_value.f90
!
! -----------------------------------------------------------------------------------------------------------
!
! Revision history
! date     who    what
! 20170712 all    Release of qcplus v1.1 - many changes to all, some documented/tracked, some not
! 20160511 all    Initial release of qcplus v1.1.0
!
! ===========================================================================================================
! Notes
!
! Function return values:
!  0 = NOQC - cannot be determined
!  1 = GOOD - druve.jump did NOT coour
!  3 = BAD  - druve.jump DID coour
!

integer function qc13_stuck_value(caller,itype,datcol)

use communication                       ! module
use data_arrays                         ! module

implicit none

! ===========================================================================================================
! varialbe/array declarations

character(*), intent( in ) :: caller
integer,      intent( in ) :: itype
integer,      intent( in ) :: datcol

character(len=4), parameter :: sub = 'QC13'
character(len=21) ,parameter :: QCTEST='Constant Value Test'
integer :: result;

integer :: ngood,nbad,nskip;
integer :: counter
real :: value_to_compare

integer :: beg, end, flag

! ===========================================================================================================
! executable statements

result = NOQC ! cannot be determined

if(DBGIO) call dbg_enter_type(sub,parmname(itype))

idat = datcol;
result = BAD;	! Assume failure
nskip=1;
value_to_compare = profdata(idat,1);

do ilev=2,nlev
    if(DBLEV==13)then;write(msg,*)"flag,data=",profflag(idat,ilev),",",profdata(idat,ilev);call wrtdbg(sub,msg);endif
    if(profflag(idat,ilev) .eq. 9 )then; nskip = nskip + 1;  go to 99; endif ! Skip this level
    if(profdata(idat,ilev) /= value_to_compare)then
	result = GOOD;	! We have a winner - not stuck
	go to 999; ! Skip to THE_END
    endif
    99 continue
enddo

if(DEBUG)then; write(msg,'("The working loop completed, ALL VAUES ARE THE SAME = CONSTANT")'); call wrtdbg(sub,msg); endif

999 continue ! This is THE_END

!If all levels are fillValues
if(DBLEV==13)then;write(msg,*)"nskip,nlev=",nskip,",",nlev;call wrtdbg(sub,msg);endif
if(nskip .eq. nlev)result = NOQC;

! The result to return to the main is based on the first data field - pres/temp/psal/doxy for primary profile

if(DBGIO) call dbg_leave_type(sub,parmname(itype),result);

! For the individual/full-profile tests, report the result directly to all files

write(msg,'("Stuck Value Test ",a1,10x,a)')parmchar(itype),flagreport(result); call wrttrc(sub,msg);

if(result==BAD)then;
    do ilev = 1,nlev
	if(profflag(idat,ilev) < BAD) profflag(idat,ilev) = BAD;
    enddo
    if(itype==S(1) .and. do_psal_adj)then
	do ilev = 1,nlev
	    if(profflag((idat+1),ilev) < BAD) profflag((idat+1),ilev) = BAD; ! psal adj is next to reg pdal
	enddo
    endif
endif

flag = 0 ! not determined, default
if(result == GOOD)then; flag = 1; elseif(result == BAD)then; flag = 4; endif
qc13_stuck_value = result;
if(itype == 2)then; beg=T(2); end=T(3); else; beg=s(2); end=S(3); endif

iprf = REGPRFCORE(idat); ! Is this a regular CORE ARGO profile?
if(iprf > 0)then; QCTEST_FLAG(iprf,13) = max(QCTEST_FLAG(iprf,13),result); endif

return
end function qc13_stuck_value
! ===========================================================================================================
